// AddNewSecret.cpp : implementation file
//

#include "stdafx.h"
#include "SQLProxy.h"
#include "AddNewSecret.h"
#include "KeyMngmnt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CKeyMngmnt kmgmnt;

/////////////////////////////////////////////////////////////////////////////
// CAddNewSecret dialog


CAddNewSecret::CAddNewSecret(CWnd* pParent /*=NULL*/)
	: CDialog(CAddNewSecret::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddNewSecret)
	m_pass = _T("");
	m_strUser1 = _T("");
	m_strUser2 = _T("");
	//}}AFX_DATA_INIT
}


void CAddNewSecret::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddNewSecret)
	DDX_Control(pDX, IDC_USER2, m_user2);
	DDX_Control(pDX, IDC_USER1, m_user1);
	DDX_Text(pDX, IDC_PASSWD, m_pass);
	DDX_CBString(pDX, IDC_USER1, m_strUser1);
	DDX_CBString(pDX, IDC_USER2, m_strUser2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddNewSecret, CDialog)
	//{{AFX_MSG_MAP(CAddNewSecret)
	ON_BN_CLICKED(IDOK, OnOKAdd)
	ON_BN_CLICKED(IDC_BUTTON_TEST, OnButtonTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddNewSecret message handlers

void CAddNewSecret::OnOKAdd() 
{
	UpdateData();
	kmgmnt.AddUser(m_strUser1);
	kmgmnt.AddUser(m_strUser2);
	
	if(m_strUser1 != "" && m_strUser2 != "" && m_pass != "")
			kmgmnt.AddSecret(m_strUser1,m_strUser2,m_pass);

	EndDialog(IDOK);
}

BOOL CAddNewSecret::OnInitDialog() 
{
	CDialog::OnInitDialog();
	POSITION pos = kmgmnt.m_map.GetStartPosition();
	void *v;
	CString key;
	while (pos != NULL)
	{	   
	   kmgmnt.m_map.GetNextAssoc(pos,key,v);
	   m_user1.AddString(key);
	   m_user2.AddString(key);
	}
	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddNewSecret::OnButtonTest() 
{
	UpdateData();
	AfxMessageBox("The secret <"+ kmgmnt.GetSecret(m_strUser1,m_strUser2) 
				+ "> from " + m_strUser1 + " to " + m_strUser2 +" is deleted!");
	kmgmnt.DelSecret(m_strUser1,m_strUser2);
}
