// KeyMngmnt.h: interface for the CKeyMngmnt class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_KEYMNGMNT_H__E9226515_70C5_4C16_AA56_5B2D278AB3F2__INCLUDED_)
#define AFX_KEYMNGMNT_H__E9226515_70C5_4C16_AA56_5B2D278AB3F2__INCLUDED_

#include "StdAfx.h"
#include <afxcoll.h>



#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CKeys
{
public:
	CString name;
	CString pub_key;
	CString priv_key;
	CString passwd;
	int LoadKeys(const CString &name);
	void GenerateKeys(CString &name,CString &seed);	
};

class CKeyMngmnt  
{
public:
	void AddUser(CString &s);
	void DelSecret(CString &u1,CString &u2);
	void AddSecret(CString u1,CString u2,CString pass);
	void SaveSecrets();
	void LoadSecrets();
	CString GetSecret(CString u1,CString u2);
	CString DecryptString(const CString &from,const CString &to,const CString &in);
	CString EncryptString(const CString &from,const CString &to,const CString &in);
	CKeyMngmnt();
	virtual ~CKeyMngmnt();

	CMapStringToPtr m_map;
	CMapStringToString m_secrets;
	//CList<CString,CString&> communication_parts;
};

#endif // !defined(AFX_KEYMNGMNT_H__E9226515_70C5_4C16_AA56_5B2D278AB3F2__INCLUDED_)
