// ProxyBuffer.h: interface for the CProxyBuffer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROXYBUFFER_H__09FA56AE_5FFD_44DA_982B_D405C7CB59C9__INCLUDED_)
#define AFX_PROXYBUFFER_H__09FA56AE_5FFD_44DA_982B_D405C7CB59C9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define yahoo_put16(buf, data) ( \
		(*(buf) = (u_char)((data)>>8)&0xff), \
		(*((buf)+1) = (u_char)(data)&0xff),  \
		2)
#define yahoo_get16(buf) ((((*(buf))<<8)&0xff00) + ((*((buf)+1)) & 0xff))
#define yahoo_put32(buf, data) ( \
		(*((buf)) = (u_char)((data)>>24)&0xff), \
		(*((buf)+1) = (u_char)((data)>>16)&0xff), \
		(*((buf)+2) = (u_char)((data)>>8)&0xff), \
		(*((buf)+3) = (u_char)(data)&0xff), \
		4)
#define yahoo_get32(buf) ((((*(buf))<<24)&0xff000000) + \
		(((*((buf)+1))<<16)&0x00ff0000) + \
		(((*((buf)+2))<< 8)&0x0000ff00) + \
		(((*((buf)+3)    )&0x000000ff)))

#define BUFMAX 10240


class CProxyBuffer  
{

	char *buf;
	 int begin;
	 int size;
	 int max;
public:
	void AdjustContentLength(int delta);
	void * GetRowBuf();
	int GetNextYMSG_Message(char *&ch,int &sz);
	 void Realoc(int nsz);
	 void Add(const void *b,int sz);
	 void *Sub(int sz);
	 int GetSize();
	 int DetectYMSG_test_packt(char *&ch,char *&ch_YMSG,int &sz);
	 CString GetHostAndPort(int &port);
	 void* GetUntil_any_YMSG(int &sz);
	 void * SubAll(int &sz);
	 CProxyBuffer();
	 virtual ~CProxyBuffer();

};

#endif // !defined(AFX_PROXYBUFFER_H__09FA56AE_5FFD_44DA_982B_D405C7CB59C9__INCLUDED_)
