#if !defined(AFX_SPROXY_H__67FA9A38_5618_4E17_9444_69E1792BDBC7__INCLUDED_)
#define AFX_SPROXY_H__67FA9A38_5618_4E17_9444_69E1792BDBC7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SProxy.h : header file
//



/////////////////////////////////////////////////////////////////////////////
// CSProxy command target


class CSProxy : public CSocket
{
// Attributes
public:

// Operations
public:
	CSProxy();
	virtual ~CSProxy();

// Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSProxy)
	public:
	virtual void OnReceive(int nErrorCode);
	virtual void OnAccept(int nErrorCode);
	virtual void OnClose(int nErrorCode);
	virtual void OnConnect(int nErrorCode);
	virtual int Send(const void* lpBuf, int nBufLen, int nFlags = 0);
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CSProxy)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
	public:
		int DirectSend(const void* lpBuf, int nBufLen, int nFlags);
		int contor;
		int m_BytesReceived;
		BOOL m_bLocalSide;
		/*
		BOOL m_bNotConnected;
		BOOL m_bNotSendDirect;
		*/
		int m_status;
		CProxyBuffer m_buffer;		
		BOOL m_bMustCrypt;
	/*static int port;
	static CString destinatie;
	*/
	BOOL m_IServer;
protected:
   FILE *fp;
   CSProxy *peer;
   BOOL m_bClosed;
};

#define SOCK_UNINTIALIZED			   1
#define SOCK_CONNECTED_AND_FREE        2
#define SOCK_WAITING_FOR_DESTINATION   3
#define SOCK_WAITING_PACKET            4
#define SOCKET_HAS_PACKET              5
#define SOCKET_CLOSED                  6

/* m_status states

   SOCK_UNINTIALIZED --> SOCK_CONNECTED_AND_FREE
    |                                  |
   \ /                                 |
   SOCK_WAITING_FOR_DESTINATION        |
    |                                  |
   \ /                                 |
   SOCK_WAITING_PACKET------------------
    |         / \     |
   \ /         |      |
   SOCK_HAS_PACKET----|
					  |
				SOCKET_CLOSED



*/

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPROXY_H__67FA9A38_5618_4E17_9444_69E1792BDBC7__INCLUDED_)
